unit WaitUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TWaitForm = class(TForm)
    BlurbLabel: TLabel;
    Timer1: TTimer;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    { Private declarations }
  public
    procedure GoWait(EstTime: Integer);
    { Public declarations }
  end;

var
  WaitForm: TWaitForm;

implementation

{$R *.DFM}

{ TWaitForm }

procedure TWaitForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  Params.WndParent := Application.MainForm.Handle;
end;

procedure TWaitForm.GoWait(EstTime: Integer);
var
  ETA: TDateTime;
  Hour, Minute, Second, Millisecond: Word;

begin
  ETA := Now + 1/4/SecsPerDay * EstTime;
  DecodeTime(ETA, Hour, Minute, Second, Millisecond);
  BlurbLabel.Caption := 'Estimated Done: ' + Format('%d:%.2d:%.2d', [ Hour, Minute, Second ]);
  BlurbLabel.Font.Size := 16;
  Show;
  Application.ProcessMessages;
end;

end.
